// HKMission61Script.
//=============================================
class HKMission61Script expands MissionScript;


function InitStateMachine()
{
   super.InitStateMachine();
   FirstFrame();

}

// ----------------------------------------------------------------------
// PreTravel()
// 
// Set flags upon exit of a certain map
// ----------------------------------------------------------------------

function PreTravel()
{

	local int count;
	local ScubaDiver Scuba;

	if (localURL == "61_HONGKONG_FACTORY")
	{
		if (flags.GetBool('M61FactoryShowXVA') && !flags.GetBool('YoonGoonsKilled'))
		{
			count = 0;
			foreach AllActors(class'ScubaDiver', Scuba)
				count++;

			if (count == 0)
			flags.SetBool('YoonGoonsKilled', True,, 62);
		}
	}

	Super.PreTravel();
}


function firstframe()
{

   local DamageTrigger D;
	local DeusExMover M;
	local Actor A;
	local Datacube Datacube;

	Super.FirstFrame();

   if (localURL == "61_HONGKONG_FACTORY")
   {
      //make sure the damagetrigger is definitely not active, since we're
      //now using it merely as a placeholder

      foreach Allactors(Class'DamageTrigger', D, 'GettingHurt')
         D.bIsOn=false;
   }

   if (localURL == "61_HONGKONG_FACTORY")
   {
		if (!flags.GetBool('M61_OpenA'))
		{
			Player.StartDataLinkTransmission("DL_HK61_ZavichIntro");
			foreach AllActors(class'Actor', A, 'BabaTriggaLuga')
				A.Trigger(Self, Player);
			flags.SetBool('M61_OpenA', True,, 62);
		}
		if(flags.getbool('M60YakedoVaultOpened') && !flags.GetBool('YakedoHatesIngram'))
		{
				flags.setbool('YakedoSpecialHate55',true,, 62);
				flags.setbool('YakedoHatesIngram',true,, 68);
		}
	Player.GoalCompleted('MeetYakedo');
	Player.GoalCompleted('GoToTuenMun');
   }

   if (localURL == "61_HONGKONG_FORICHI")
	{
		if(flags.getbool('M60ForichiShopBreakIn') && !flags.GetBool('LillityLacs'))
		{
			foreach AllActors(class'Actor', A, 'm61ForichiShopClosed')
				A.Trigger(Self, Player);
				flags.setbool('LillityLacs',true,, 62);
		}
		if(flags.GetBool('M60Win2Broke') && !flags.GetBool('SimoPher'))
		{
			foreach AllActors(class'DeusExMover', M, 'M61PolizeiStorageGlass')
			{
				M.bBreakable = False;
			}
			foreach AllActors(class'DataCube', DataCube, 'CubeOfBrakes')
			{
			DataCube.bHidden = False;
			}
			flags.setbool('SimoPher',true,, 62);
		}
	}


   if (localURL == "61_HONGKONG_MPSHELIPAD")
   {
	Player.GoalCompleted('CaptureDavidYoon');
  }
}

function Timer()
{
	local SphereEffect sphere;
   local DamageTrigger D;
   local float dist;
	local Mechanic Joe;
	local ScriptedPawn P;
	local LowerClassMale2 YoonGoon;
	local LowerClassMale2 YoonGoon2;
	local XVATroop XVAGoon2;
	local AttackHelicopter chopper;
	local BlackHelicopter lanacopter;
	local HKMilitary HKMilitary;
	local DeusExMover M;
   local Actor A; //changed to actor to make it affect everything (decos etc): if unnecessary, change back to scriptedpawn
	local SpawnPoint SP;
	local AugmentationCannister AugmentationCannister;
	local TriadLumPath TriadLumPath;
	local TriadLumPath2 TriadLumPath2;
	local ThugMale3 ThugMale3;
	local int count;
	local ScubaDiver Scuba;
	local WaterZone WaterZone;
	local Robot Robot;
	local Datacube datacube;
	local SecurityCamera cam;

   Super.Timer();

	if (flags.GetBool('VTOLDeedDone'))
	{
		if (!flags.GetBool('VTOLDamageStarted'))
		{
			if (Player.IsInState('Dying'))
			{
				flags.SetBool('VTOLDamageStarted', True,, 5);
				Level.Game.SendPlayer(Player, "62_BERLIN_AIRBORNELAB");
			}
		}
	}

   if (localURL == "61_HONGKONG_FACTORY")
   {
      if (flags.GetBool('YoonDamageStarts') && !flags.GetBool('YoonDamageDone'))
      {
         	foreach AllActors(Class'Damagetrigger', D, 'GettingHurt')
         	{
            		foreach RadiusActors(Class'Actor', A, D.collisionradius,D.location)
              		A.takedamage(D.DamageAmount, none, D.location, vect(0,0,0), D.damagetype);
       		}
		foreach AllActors(class'Mechanic', Joe)
		{
			Joe.HealthTorso = 0;
			Joe.Health = 0;
			Joe.TakeDamage(1, Joe, Joe.Location, vect(0,0,0), 'PoisonGas');
		}
      }

		if (flags.GetBool('EnoughGas') &&
			flags.GetBool('YoonDamageStarts'))
		{
			Player.StartDataLinkTransmission("DL_HK61_MeetTakara");
			flags.SetBool('HK_TakaraDLPlayed', True,, 62);
		}

   }       

	if (localURL == "61_HONGKONG_FACTORY")
	{
		if (flags.GetBool('JKRefTriggered') && !flags.GetBool('M61_WaterUnleashed'))
		{
				foreach AllActors(class'WaterZone', WaterZone, 'JKRef')
					{
					WaterZone.bWaterZone = True;
					WaterZone.SoundVolume = 128;
					}
				foreach AllActors(class'Actor', A, 'JKRefMover')
				A.Trigger(Self, Player);
				foreach AllActors(class'Actor', A, 'RefSkills')
				A.Trigger(Self, Player);
				foreach AllActors(class'Actor', A, 'JKRefAction')
				A.Trigger(Self, Player);
			foreach AllActors(class'DeusExMover', M, 'RefDoor')
			{
				M.bLocked = False;
				M.bBreakable = True;
				M.bFrobbable = True;
				M.bHighlight = True;
				M.bPickable = True;
			}
				flags.SetBool('M61_WaterUnleashed', True,, 62);
			
		}
		if(flags.GetBool('JoeSurvived') && !flags.GetBool('JoeIsSafeForever'))
		{
			foreach AllActors(class'Actor', A, 'FunkyJoeDoor')
				A.Trigger(Self, Player);
			foreach AllActors(class'ScriptedPawn', P)
			{
			if (P.BindName == "JoeMechanic")
					{
			foreach AllActors(class'Mechanic', Joe)
				Joe.LeaveWorld();
			foreach AllActors(class'Actor', A, 'JoeBonus')
				A.Trigger(Self, Player);
							flags.setbool('JoeIsSafeForever',true);
					}


					}
				}

	if (flags.GetBool('M61FactoryShowXVA') && !flags.GetBool('FactoryNuts0A'))
	{
		foreach AllActors(class'ScubaDiver', scuba)
		scuba.EnterWorld();
		flags.SetBool('FactoryNuts0A', True,, 62);
	}
			
}

   if (localURL == "61_HONGKONG_STREETS")
   {

	if (!flags.GetBool('M61FolderGag'))
	{
		foreach AllActors(class'Datacube', Datacube)
		{
			if (flags.GetBool('M60Win2Broke'))
			{
				if ((Datacube.BindName == "M61ExtraCuboyne"))
				{
				Datacube.bHidden = False;
				flags.SetBool('M61FolderGag', True,, 62);
				}
			}
		}
	}

	if (!flags.GetBool('M61DoorPeijaiset') && !flags.GetBool('M61ToiletAmbushed'))
	{
		foreach AllActors(class'DeusExMover', M, 'ShingToilet')
		{
			if (M.bDestroyed)
			{
			foreach AllActors(class'Actor', A, 'NicePronus333')
				A.Trigger(Self, Player);
			foreach AllActors(class'Actor', A, 'AptMadness')
				A.Trigger(Self, Player);
				flags.SetBool('M61DoorPeijaiset', True,, 62);
			}
		}
	}





	if (flags.GetBool('M61FoundService2') && !flags.GetBool('ServiceFound2') && !flags.GetBool('M61ToiletAmbushed'))
	{
		foreach AllActors(class'ScriptedPawn', P)
		{
		if (P.BindName == "YoonGoon")
		{
		foreach AllActors(class'LowerClassMale2', YoonGoon)
		YoonGoon.EnterWorld();
			foreach AllActors(class'Actor', A, 'GoonDoor')
				A.Trigger(Self, Player);
			foreach AllActors(class'DeusExMover', M, 'GoonDoor')
			{
				M.bLocked = False;
				M.bBreakable = True;
				M.bFrobbable = True;
				M.bHighlight = True;
				M.bPickable = True;
			}
		flags.SetBool('ServiceFound2', True,, 62);
		}
	}
	}
if (!flags.GetBool('M61AmbushTwo'))
{

	if (flags.GetBool('M61ToiletAmbushed'))
	{
		foreach AllActors(class'ScriptedPawn', P)
         	{
			if (P.BindName == "XVAGoon2")
			{
			foreach AllActors(class'XVATroop', XVAGoon2)
			XVAGoon2.EnterWorld();
				foreach AllActors(class'DeusExMover', M)
				{
					if (M.Tag == 'ShingToilet')
					{
						M.bLocked = False;
						M.bFrobbable = True;
						M.bHighlight = True;
						M.bBreakable = True;
						M.bPickable = True;
					}
				}
				foreach AllActors(class'DeusExMover', M)
				{
					if (M.Tag == 'DoorCtorDoom1421')
					{
						M.bLocked = False;
						M.bBreakable = True;
						M.bPickable = True;
					}
				}
				foreach AllActors(class'SecurityCamera', cam)
					if (cam.Tag == 'June1418Camera')
					{
						cam.bNoAlarm = False;
					}
			flags.SetBool('M61AmbushTwo', True,, 62);
         		}
		}
   }   
}
}





   if (localURL == "61_HONGKONG_FORICHI")
   {
		if (!flags.GetBool('M61_MoverUnlocked') && flags.GetBool('ZavichOpensDoor'))
		{
			foreach AllActors(class'DeusExMover', M, 'ZavichDoor')
			{
				M.bLocked = False;
				M.lockStrength = 0.0;
			}
			flags.SetBool('M61_MoverUnlocked', True,, 62);
		}
		}
   if (localURL == "61_HONGKONG_FORICHI")
   {
		if (flags.GetBool('M61HeliNoted') && !flags.GetBool('M61notePlayed'))
		{
			Player.StartDataLinkTransmission("DL_HK61_HelipadInfo");
			flags.SetBool('M61notePlayed', True,, 62);
		}
		if (flags.GetBool('M61UnlockWoohoo') && !flags.GetBool('WoohooUnlock'))
		{
			Player.StartDataLinkTransmission("DL_HK61_ZavichGotIt");
			flags.SetBool('WoohooUnlock', True,, 62);
		}
		if (flags.GetBool('FalseFlagInfolink') && !flags.GetBool('FalselyFlagged'))
		{
			Player.StartDataLinkTransmission("DL_HK61_ZavichFalseFlag");
			flags.SetBool('FalselyFlagged', True,, 62);
		}
		if (flags.GetBool('M62AdminInside') && !flags.GetBool('LuminousPathAlliance') && !flags.GetBool('RiggidyBraxicon'))
		{
			foreach AllActors(class'Actor', A, 'LuminousWRATH')
				A.Trigger(Self, Player);
			flags.SetBool('RiggidyBraxicon', True,, 62);
		}
		if (flags.GetBool('BotGoodieChecker') && !flags.GetBool('BotGoodie') && !flags.GetBool('BotGoodieZeta'))
		{
			foreach AllActors(class'Actor', A, 'M61BotBaddie')
				A.Trigger(Self, Player);
			flags.SetBool('BotGoodieZeta', True,, 62);
		}
		if (flags.GetBool('KindLumPathThing') && !flags.GetBool('UnlockBarbie'))
		{
			foreach AllActors(class'DeusExMover', M)
			{
				if ((M.Tag == 'ForiOffEntry2') || (M.Tag == 'ForiOffEntry1') || (M.Tag == 'PuertaBar'))		
				{
				M.bLocked = False;
				M.lockStrength = 0.0;
				}
			}
			flags.SetBool('UnlockBarbie', True,, 62);
		}
		if (!flags.GetBool('Antebellum1'))
		{
			foreach AllActors(class'DeusExMover', M, 'ForiOffEntry2')
				if (M.bDestroyed)
					{
					foreach AllActors(class'Actor', A, 'AdminInside')
					A.Trigger(Self, Player);
					flags.SetBool('Antebellum1', True,, 62);
					}
		}
		if (!flags.GetBool('Antebellum1B'))
		{
			foreach AllActors(class'DeusExMover', M, 'ForiOffEntry1')
				if (M.bDestroyed)
					{
					foreach AllActors(class'Actor', A, 'AdminInside')
					A.Trigger(Self, Player);
					flags.SetBool('Antebellum1B', True,, 62);
					}
		}
		if (!flags.GetBool('Antebellum1C'))
		{
			foreach AllActors(class'DeusExMover', M, 'PuertaBar')
				if (M.bDestroyed)
					{
					foreach AllActors(class'Actor', A, 'AdminInside')
					A.Trigger(Self, Player);
					flags.SetBool('Antebellum1C', True,, 62);
					}
		}
   }





   if (localURL == "61_HONGKONG_FORICHI")
   {
		if (flags.GetBool('IntSecMil1_Dead') && flags.GetBool('IntSecMil2_Dead') && flags.GetBool('IntSecMil3_Dead') && flags.GetBool('IntSecMil4_Dead') && flags.GetBool('IntSecMil5_Dead') && !flags.GetBool('M61HelitroopsDead'))
		{
			flags.SetBool('HelipadHandled', True,, 62);
			Player.StartDataLinkTransmission("DL_HK61_HelipadCleared");
			foreach AllActors(class'Actor', A, 'OvalSN1111Stash')
				A.Trigger(Self, Player);
			flags.SetBool('M61HelitroopsDead', True,, 62);
		}

		if (flags.GetBool('DoorsOpened') && !flags.GetBool('M61HeliDoor'))
		{
			foreach AllActors(class'BlackHelicopter', lanacopter, 'CopterExit')
			lanacopter.EnterWorld();
			flags.SetBool('M61HeliDoor', True,, 62);
		}

		if (flags.GetBool('HelipadHandled') && !flags.GetBool('M61Handled2'))
		{
			foreach AllActors(class'Actor', A, 'ThatComp2')
			{
						SP = GetSpawnPoint('Compoint');
						if (SP != None)
						{
							A.SetLocation(SP.Location);
							A.SetRotation(SP.Rotation);
						}
			}
			foreach AllActors(class'Actor', A, 'ThatComp')
			{
						SP = GetSpawnPoint('Nonpoint');
						if (SP != None)
						{
							A.SetLocation(SP.Location);
							A.SetRotation(SP.Rotation);
						}
			}
			flags.SetBool('M61Handled2', True,, 62);
		}

		if (flags.GetBool('M61DoorLock') && !flags.GetBool('M61Handled20'))
		{
			foreach AllActors(class'ScriptedPawn', P, 'XVAPatch1')
			{
						SP = GetSpawnPoint('XVAComes1');
						if (SP != None)
						{
							P.SetLocation(SP.Location);
							P.SetRotation(SP.Rotation);
						}
			}
			foreach AllActors(class'ScriptedPawn', P, 'XVAPatch12')
			{
						SP = GetSpawnPoint('XVAComes12');
						if (SP != None)
						{
							P.SetLocation(SP.Location);
							P.SetRotation(SP.Rotation);
						}
			}
			foreach AllActors(class'ScriptedPawn', P, 'XVAPatch13')
			{
						SP = GetSpawnPoint('XVAComes13');
						if (SP != None)
						{
							P.SetLocation(SP.Location);
							P.SetRotation(SP.Rotation);
						}
			}
			foreach AllActors(class'ScriptedPawn', P, 'XVAPatch14')
			{
						SP = GetSpawnPoint('XVAComes14');
						if (SP != None)
						{
							P.SetLocation(SP.Location);
							P.SetRotation(SP.Rotation);
						}
			}
			foreach AllActors(class'Actor', A, 'M61ReturnCopMadDop')
				A.Trigger(Self, Player);
			flags.SetBool('M61Handled20', True,, 62);
		}

   }





   if (localURL == "61_HONGKONG_MPSHELIPAD")
   {


		if (flags.GetBool('M61Debriefing_Played') && !flags.GetBool('JuneAppeared'))
		{
			foreach AllActors(class'Actor', A, 'June2339')
			A.Trigger(Self, Player);
				foreach AllActors(class'DeusExMover', M)
				{
					if (M.Tag == 'June2339')
					{
						M.bLocked = False;
					}
				}
			flags.SetBool('JuneAppeared', True,, 62);
		}

		if (flags.GetBool('KOFlag') && !flags.GetBool('M62KnockOutDone'))
		{
			Player.HealthHead = Max(50, Player.HealthHead);
			Player.HealthTorso =  Max(50, Player.HealthTorso);
			Player.HealthLegLeft =  0;
			Player.HealthLegRight =  0;
			Player.HealthArmLeft =  Max(50, Player.HealthArmLeft);
			Player.HealthArmRight =  Max(50, Player.HealthArmRight);
			Player.GenerateTotalHealth();
			Player.PlaySound(Sound'EMPGrenadeExplode', SLOT_None, 2.0,, 16384);
			Player.ShakeView(1.0, 1024.0, 32.0);


					Spawn(class'ExplosionLight',,, Player.Location);
					Spawn(class'EllipseEffect',,, Player.Location);
					sphere = Spawn(class'SphereEffect',,, Player.Location);
					if (sphere != None)
						sphere.size = 4.0;
					
				
			flags.SetBool('M62KnockOutDone', True,, 63);
		}
		if (flags.GetBool('FGRHKAugsRetrieved') && !flags.GetBool('M61Augumentation'))
		{
				foreach AllActors(class'AugmentationCannister', AugmentationCannister, 'prizeaugs')
					AugmentationCannister.Destroy();
				foreach AllActors(class'DeusExMover', M)
				{
					if (M.Tag == 'YannickDoor')
					{
						M.bLocked = False;
					}
				}
			flags.SetBool('M61Augumentation', True,, 62);
		}
}
		



   if (localURL == "61_HONGKONG_TIANBAOHOTEL")
   {

		if (flags.GetBool('Chaolan_Dead') && !flags.GetBool('M61Dicketing'))
		{
			foreach AllActors(class'DeusExMover', M)
				{
					if (M.Tag == 'chaolan1d2')
					{
						M.bBreakable = True;
						M.bPickable = True;
					}
				}
			foreach AllActors(class'DeusExMover', M)
				{
					if (M.Tag == 'chaolan1d')
					{
						M.bBreakable = True;
						M.bPickable = True;
					}
				}
			flags.SetBool('M61Dicketing', True,, 62);
		}

		if (flags.GetBool('M61SuperBotDisablus') && !flags.GetBool('BotJacquepotM61'))
		{
			foreach AllActors(class'Robot', Robot)
			{
			Robot.empHitpoints = 0;
			Robot.TakeDamage(1, Robot, Robot.Location, vect(0,0,0), 'EMP');
			flags.SetBool('BotJacquepotM61', True,, 62);
			}
		}
		if (flags.GetBool('M61EnteredTheBuilding'))
		{
			Player.StartDataLinkTransmission("DL_HK61_ZavichExposition");
			flags.SetBool('M61ZavichDL2Played', True,, 62);
		}
		if (!flags.GetBool('HotelBotMadness'))
			{
			foreach AllActors(class'DeusExMover', M)
			{
				if ((M.Tag == 'BotDorores01'))
				{
					// close and lock the door
					if (M.KeyNum != 0)
					{
					foreach AllActors(class'Actor', A, 'BordersTrugger')
					A.Trigger(Self, Player);
					}
					flags.SetBool('HotelBotMadness', True,, 62);
				}
			}
			}
		
		

}


   if (localURL == "61_HONGKONG_TIANBAOHOTEL")
   {

		if (flags.GetBool('M61InterruptusAppears') && !flags.GetBool('InterruptorJones'))
		{
			foreach AllActors(class'ScriptedPawn', P)
			{
			if (P.BindName == "YoonInterruptus")
			{
			foreach AllActors(class'HKMilitary', HKMilitary)
			HKMilitary.EnterWorld();
			flags.SetBool('InterruptorJones', True,, 62);
			}
		}
		}
		}

}





defaultproperties
{
}