//=============================================
// WDCMission66Script.
//=============================================
class WDCMission66Script expands MissionScript;

function InitStateMachine() {

    super.InitStateMachine();
    FirstFrame();

}

// ----------------------------------------------------------------------
// FirstFrame()
// 
// Stuff to check at first frame
// ----------------------------------------------------------------------

function FirstFrame()
{

	local Actor A;
	local float rnd;

	Super.FirstFrame();

	if (localURL == "66_WHITEHOUSE_STREETS")
	{

		if (!flags.GetBool('M66_Open'))
		{
			Player.StartDataLinkTransmission("DL_M66_ZavichDeparts");
			flags.SetBool('M66_Open', True,, 67);
		}
		if (flags.GetBool('FGRHKNoWeapons') && !flags.GetBool('M66Whatever'))
		{

			rnd = FRand();

			if (rnd < 0.33)
			{
			flags.SetBool('M60WeaponsPistol', True,, 0);
			}
			else if (rnd < 0.66)
			{
			flags.SetBool('M60WeaponsRifle', True,, 0);
			}
			else
			{
			flags.SetBool('M60WeaponsLowtech', True,, 0);
			}
		flags.SetBool('M66Whatever', True,, 67);
		}
	}

	if (localURL == "66_WHITEHOUSE_ILLUMINATI")
	{

		if (!flags.GetBool('M66_Illumintro'))
		{
			Player.GoalCompleted('M66GetToIlluminati');
			flags.SetBool('M66_Illumintro', True,, 67);
		}


	}

	if (localURL == "66_WHITEHOUSE_EXTERIOR")
	{

		if (!flags.GetBool('M66_OutOfMyDreams'))
		{
			foreach AllActors(class'Actor', A, 'Maglev1')
				A.Trigger(Self, Player);
			flags.SetBool('M66_OutOfMyDreams', True,, 67);
		}


	}


}

function Timer()
{

	local DeusExMover M;
	local NumberOne	NumberOne;
	local NYEagleStatue NYEagleStatue;
	local LienTakara LienTakara;
	local Actor A;
	local ScriptedPawn ScriptedPawn;
	local BlackHelicopter lanacopter;
	local ScriptedPawn P;
	local SecretService SecretService;
	local SpawnPoint SP;
	local float h;
	local Ammo20mm Ammo20mm;
	local Ammo10mm Ammo10mm;
	local Ammo762mm Ammo762mm;
	local AmmoDart AmmoDart;
	local AmmoDartFlare AmmoDartFlare;
	local AmmoDartPoison AmmoDartPoison;
	local WeaponWaltherDXN WeaponWaltherDXN;
	local WeaponMinicrossbow WeaponMinicrossbow;
	local WeaponSMG5 WeaponSMG5;
	local WeaponMod WeaponMod;
	local MJ12Commando MJ12Commando;
	local int count;

   Super.Timer();

	if (localURL == "66_WHITEHOUSE_ILLUMINATI")
   	{

		if (flags.GetBool('M66DatWall') && !flags.GetBool('Gerbil'))
		{
			foreach AllActors(class'Actor', A, 'M66DatWall')
			{
			A.Trigger(Self, Player);
			}
			flags.SetBool('Gerbil', True,, 68);
		}
		if (!flags.GetBool('M66DatWall'))
		{
			foreach AllActors(class'DeusExMover', M, 'M66DatWall')
				if (M.bDestroyed)
			flags.SetBool('M66DatWall', True,, 67);
		}
		if (flags.GetBool('M66DecryptDone') && !flags.GetBool('DecryptHandled'))
		{
			Player.StartDataLinkTransmission("DL_M66_DecryptionComplete");
			flags.SetBool('DecryptHandled', True,, 67);
		}
		if (flags.GetBool('DL_M66_DecryptionComplete_PLayed') && !flags.GetBool('DecryptHandled100'))
		{
			foreach AllActors(class'Actor', A, 'OvalStash')
			{
			A.Trigger(Self, Player);
			}
			foreach AllActors(class'Actor', A, 'MacTonightM66')
			{
			A.Trigger(Self, Player);
			}
			flags.SetBool('DecryptHandled100', True,, 67);
		}


	}

   if (localURL == "66_WHITEHOUSE_EXTERIOR")
   {

		if (flags.GetBool('M66WH_Arrived') && !flags.GetBool('ArrivalHandled'))
		{
			foreach AllActors(class'DeusExMover', M, 'Maglev1')
				M.BumpEvent = ('None');
				M.AttachTag = ('Maglev1Platform');
			foreach AllActors(class'Actor', A, 'LutherVandross2')
				A.Trigger(Self, Player);
			flags.SetBool('ArrivalHandled', True,, 67);
		}
		if (flags.GetBool('M66OneAppears') && !flags.GetBool('EnterSenior'))
		{
			foreach AllActors(class'NumberOne', NumberOne)
			NumberOne.EnterWorld();
			flags.SetBool('EnterSenior', True,, 67);
			foreach AllActors(class'NYEagleStatue', NYEagleStatue)
			{
				if (NYEagleStatue.Tag == 'NYEagleStatue')
					NYEagleStatue.bHidden = True;
			}
		}
		if (flags.GetBool('NumberFour_Played') && !flags.GetBool('SeniorGone'))
		{
			foreach AllActors(class'NumberOne', NumberOne)
			NumberOne.LeaveWorld();
			flags.SetBool('SeniorGone', True,, 67);
			foreach AllActors(class'NYEagleStatue', NYEagleStatue)
			{
				if (NYEagleStatue.Tag == 'NYEagleStatue')
					NYEagleStatue.bHidden = False;
			}
		}
		if (!flags.GetBool('M66WHNoCommandos'))
		{
			count = 0;
			foreach AllActors(class'MJ12Commando', MJ12Commando)
					count++;
			if (count == 0)
			{
				flags.SetBool('M66WHNoCommandos', True);
			}
		}
		if (!flags.GetBool('M66WHNoAgents'))
		{
			count = 0;
			foreach AllActors(class'SecretService', SecretService)
					count++;
			if (count == 0)
			{
				flags.SetBool('M66WHNoAgents', True);
			}
		}
		if (flags.GetBool('M66DispatchGalore') && !flags.GetBool('DispatchGizmo'))
		{
			foreach AllActors(class'ScriptedPawn', P, 'DecryptDispatch')
			P.EnterWorld();
			foreach AllActors(class'Actor', A, 'DispatchMover')
			{
			A.Trigger(Self, Player);
			}
			flags.SetBool('DispatchGizmo', True,, 67);
		}
		if (!flags.GetBool('M66DatWall'))
		{
			foreach AllActors(class'DeusExMover', M, 'M66DatWall')
				if (M.bDestroyed)
			flags.SetBool('M66DatWall', True,, 67);
		}

	}

   if (localURL == "66_WHITEHOUSE_STREETS")
   {
		if (flags.GetBool('M60WeaponsLowTech') && flags.GetBool('LienRespectsIngramTier1') && flags.GetBool('LienRespectsIngramTier2') &&!flags.GetBool('M66WeaponThingOK1'))
		{
			flags.SetBool('M66WeaponCleanup', True,, 67);
			flags.SetBool('M66WeaponThingOK1', True,, 67);
		}
		if (flags.GetBool('M60WeaponsPistol') && flags.GetBool('LienRespectsIngramFinal') && !flags.GetBool('M66WeaponThingOK2'))
		{
			foreach AllActors(class'Actor', A, 'LaniPator')
			A.Trigger(Self, Player);
			foreach AllActors(class'Ammo762mm', Ammo762mm, 'LienAmmo762mm')
			Ammo762mm.Destroy();
			foreach AllActors(class'Ammo20mm', Ammo20mm, 'LienAmmo20mm')
			Ammo20mm.Destroy();
			foreach AllActors(class'WeaponSMG5', WeaponSMG5, 'LienWeaponSMG5')
			WeaponSMG5.Destroy();
			flags.SetBool('M66WeaponThingOK2', True,, 67);
		}
		if (flags.GetBool('M60WeaponsRifle') && flags.GetBool('LienRespectsIngramFinal') &&!flags.GetBool('M66WeaponThingOK3'))
		{
			foreach AllActors(class'Actor', A, 'LaniPator')
			A.Trigger(Self, Player);
			foreach AllActors(class'Ammo10mm', Ammo10mm, 'LienAmmo10mm')
			Ammo10mm.Destroy();
			foreach AllActors(class'AmmoDart', AmmoDart, 'LienAmmoDart')
			AmmoDart.Destroy();
			foreach AllActors(class'AmmoDartFlare', AmmoDartFlare, 'LienAmmoDartFlare')
			AmmoDartFlare.Destroy();
			foreach AllActors(class'AmmoDartPoison', AmmoDartPoison, 'LienAmmoDartPoison')
			AmmoDartPoison.Destroy();
			foreach AllActors(class'WeaponWaltherDXN', WeaponWaltherDXN, 'LienWeaponBeretta')
			WeaponWaltherDXN.Destroy();
			foreach AllActors(class'WeaponMinicrossbow', WeaponMinicrossbow, 'LienWeaponMinicrossbow')
			WeaponMinicrossbow.Destroy();
			flags.SetBool('M66WeaponThingOK3', True,, 67);
		}
		if (flags.GetBool('M66Park_Arrived') && !flags.GetBool('Arrival2Handled'))
		{
			foreach AllActors(class'DeusExMover', M, 'Maglev12')
				M.BumpEvent = ('None');
				M.AttachTag = ('Maglev12Platform');
			foreach AllActors(class'Actor', A, 'BillyOcean2')
				A.Trigger(Self, Player);
			flags.SetBool('Arrival2Handled', True,, 67);
		}
		if (flags.GetBool('M66LienStatus') && !flags.GetBool('LienStatusChecked'))
		{
			flags.SetBool('LienStatusChecked', True,, 67);
		}			
		if (flags.GetBool('M66ReadyForDeparture') && !flags.GetBool('DepartureHandled'))
		{
			foreach AllActors(class'BlackHelicopter', lanacopter, 'BlackHelicopter')
			lanacopter.EnterWorld();
			foreach AllActors(class'Actor', A, 'Maglev12')
				A.Trigger(Self, Player);
			flags.SetBool('DepartureHandled', True,, 67);
		}
		if (flags.GetBool('M66MissionComplete') && !flags.GetBool('ReturnToPark'))
		{
			foreach AllActors(class'LienTakara', LienTakara, 'LienTakara')
			LienTakara.EnterWorld();
			foreach AllActors(class'ScriptedPawn', P)
			{
			if (P.BindName == "LarryFay")
					{
						SP = GetSpawnPoint('Larrypoint');
						if (SP != None)
						{
							P.SetLocation(SP.Location);
							P.SetRotation(SP.Rotation);
							P.SetOrders('Standing',, True);
							P.SetHomeBase(SP.Location, SP.Rotation);

						}
							P.bInvincible = False;
							P.HealthTorso = 0;
							P.Health = 0;
							P.bStunned = True;
							P.TakeDamage(1, P, P.Location, vect(0,0,0), 'KnockedOut');
					}
			}
				Player.StartDataLinkTransmission("DL_M66_WTFLarry");
			flags.SetBool('ReturnToPark', True,, 67);
		}
		if (flags.GetBool('LienRespectsIngramFinal') && !flags.GetBool('LienZenEndHandled'))
		{		
			foreach AllActors(class'LienTakara', LienTakara, 'LienTakara')
			LienTakara.bInvincible=True;
			flags.SetBool('LienZenEndHandled', True,, 67);
		}
		if (flags.GetBool('YAAFlagM66A1') && !flags.GetBool('LienZenEndHandledA1'))
		{		
			foreach AllActors(class'DeusExMover', M, 'DoorWhateverm66')
				M.bBreakable = False;
			flags.SetBool('LienZenEndHandledA1', True,, 67);
		}
		if (flags.GetBool('LienRespectsIngramFinal') && flags.GetBool('M60WeaponsLowTech') && !flags.GetBool('SwordHandled'))
		{
			foreach AllActors(class'Actor', A, 'WeaponNanoSword')
			{
						SP = GetSpawnPoint('Nanopoint');
						if (SP != None)
						{
							A.SetLocation(SP.Location);
							A.SetRotation(SP.Rotation);
						}
			}		
			foreach AllActors(class'LienTakara', LienTakara, 'LienTakara')
			LienTakara.bInvincible=True;
			foreach AllActors(class'DeusExMover', M, 'DoorWhateverm66')
				M.bBreakable = True;
			flags.SetBool('SwordHandled', True,, 67);
		}
		if (flags.GetBool('M60WeaponCleanup') && !flags.GetBool('M66WeaponCOK'))
		{
			foreach AllActors(class'Ammo762mm', Ammo762mm, 'LienAmmo762mm')
			Ammo762mm.Destroy();
			foreach AllActors(class'Ammo10mm', Ammo10mm, 'LienAmmo10mm')
			Ammo10mm.Destroy();
			foreach AllActors(class'Ammo20mm', Ammo20mm, 'LienAmmo20mm')
			Ammo20mm.Destroy();
			foreach AllActors(class'AmmoDart', AmmoDart, 'LienAmmoDart')
			AmmoDart.Destroy();
			foreach AllActors(class'AmmoDartFlare', AmmoDartFlare, 'LienAmmoDartFlare')
			AmmoDartFlare.Destroy();
			foreach AllActors(class'AmmoDartPoison', AmmoDartPoison, 'LienAmmoDartPoison')
			AmmoDartPoison.Destroy();
			foreach AllActors(class'WeaponSMG5', WeaponSMG5, 'LienWeaponSMG5')
			WeaponSMG5.Destroy();
			foreach AllActors(class'WeaponWaltherDXN', WeaponWaltherDXN, 'LienWeaponBeretta')
			WeaponWaltherDXN.Destroy();
			foreach AllActors(class'WeaponMod', WeaponMod, 'LienWeaponMod')
			WeaponMod.Destroy();
			flags.SetBool('M66WeaponCOK', True,, 67);
		}
		if (flags.GetBool('LienTakara_Dead') && !flags.GetBool('M66WeaponThingOK5'))
		{
			foreach AllActors(class'DeusExMover', M, 'DoorWhateverm66')
				{
				M.bBreakable = False;
				M.bFrobbable = False;
				M.bHighlight = False;
				}
			flags.SetBool('M66WeaponCleanup', True,, 67);
			flags.SetBool('M66WeaponThingOK5', True,, 67);
		}
		if (!flags.GetBool('LienRespectsIngramTier1') && !flags.GetBool('M66WeaponThingOK6'))
		{
			flags.SetBool('M66WeaponCleanup', True,, 67);
			flags.SetBool('M66WeaponThingOK6', True,, 67);
		}
		if (!flags.GetBool('LienRespectsIngramTier2') && !flags.GetBool('M66WeaponThingOK7'))
		{
			flags.SetBool('M66WeaponCleanup', True,, 67);
			flags.SetBool('M66WeaponThingOK7', True,, 67);
		}
	}


   if (localURL == "66_WHITEHOUSE_STREETS")
   {

if(!flags.getbool('SaveTheLien_played') && flags.getbool('LienStatusChecked'))
   {
      foreach allactors(Class'scriptedpawn', ScriptedPawn, 'LienTakara')
      {
         h = ScriptedPawn.health/ScriptedPawn.default.health;
         if(h >= 1.0)
         {         
            flags.setbool('PawnOK',true);
			foreach AllActors(class'Actor', A, 'M66LienConversation')
			A.Trigger(Self, Player);
            break;
         }
         else if(h >= 0.5)
         {
            flags.setbool('pawnOk',false);
            flags.setbool('pawnInjured', true);
            break;
         }
         else
         {
            flags.setbool('pawnOk',false);
            flags.setbool('pawnInjured',false);
            flags.setbool('pawnFucked', true);
            break;
         }
      }
   }   

}
}



defaultproperties
{
}
