//=============================================================================
// WeaponDXNGaussGun. 
//=============================================================================
class WeaponDXNGaussGun extends WeaponGaussGun;

var float	mpNoScopeMult;

simulated function GaussSelect()
{
      Owner.PlaySound(Sound'GaussGun.GaussDeploy', SLOT_None,,, 1024); 
}

simulated function GaussClipOut()
{
      Owner.PlaySound(Sound'GaussGun.GaussClipOut', SLOT_None,,, 1024); 
}

simulated function GaussClipIn()
{
      Owner.PlaySound(Sound'GaussGun.GaussClipIn', SLOT_None,,, 1024); 
}


simulated function PreBeginPlay()
{
	Super.PreBeginPlay();

	// If this is a netgame, then override defaults
	if ( Level.NetMode != NM_StandAlone )
	{
		HitDamage = mpHitDamage;
		BaseAccuracy = mpBaseAccuracy;
		ReloadTime = mpReloadTime;
		AccurateRange = mpAccurateRange;
		MaxRange = mpMaxRange;
		ReloadCount = mpReloadCount;
      bHasMuzzleFlash = False;
      ReloadCount = 18;
      ReloadTime = ShotTime;
		recoilStrength = 0.75;
	}
}

defaultproperties
{
	LowAmmoWaterMark=18
	GoverningSkill=Class'DeusEx.SkillWeaponHeavy'
	NoiseLevel=2.00
	EnviroEffective=1
	Concealability=1
	ShotTime=2.00
	reloadTime=0.35
	HitDamage=25
	BaseAccuracy=0.70
	bHasScope=true
	bCanHaveLaser=true
	recoilStrength=0.50
	bUseWhileCrouched=true
	MinWeaponAcc=0.20
	mpReloadTime=0.30
	mpHitDamage=25
	mpAccurateRange=28800
	mpMaxRange=28800
	mpReloadCount=18
	bCanHaveModBaseAccuracy=true
	bCanHaveModReloadCount=true
	bCanHaveModAccurateRange=true
	bCanHaveModReloadTime=true
	bCanHaveModRecoilStrength=true
	AmmoName=class'fgrhk.AmmoDXNGauss'
	ReloadCount=18
	PickupAmmoCount=18
	FireOffset=(X=-16.00,Y=5.00,Z=11.50)
	ProjectileClass=class'fgrhk.DXNGaussWave'
	shakemag=450.00
	FireSound=Sound'fgrhk.Weapons.DXNGaussFire'
	InventoryGroup=58
	ItemName="Gauss Gun"
	PlayerViewOffset=(X=16.00,Y=-5.00,Z=-11.50)
	PlayerViewMesh=LodMesh'gauss1st'
	PickupViewMesh=LodMesh'gausspickup'
	ThirdPersonMesh=LodMesh'gauss3rd'
	LandSound=Sound'DeusExSounds.Generic.DropMediumWeapon'
	Icon=Texture'GaussGunIconBelt'
	largeIcon=Texture'GaussGunIconInventory'
	largeIconWidth=200
	largeIconHeight=90
	invSlotsX=4
	invSlotsY=2
	Description="Able to emit a long-range EMP explosion."
	beltDescription="GAUSS"
	Texture=FireTexture'Effects.Electricity.Wepn_EMPG_SFX'
	Mesh=LodMesh'gausspickup'
	CollisionRadius=15.00
	CollisionHeight=1.10
	Mass=40.00
}